package com.yuyu.srwildentity.listener;


import com.palmergames.bukkit.towny.TownyAPI;
import com.palmergames.bukkit.towny.event.PlayerEnterTownEvent;
import com.palmergames.bukkit.towny.event.PlayerLeaveTownEvent;
import com.palmergames.bukkit.towny.object.Town;
import com.yuyu.srwildentity.config.ConfigManager;
import io.lumine.xikage.mythicmobs.MythicMobs;
import me.clip.placeholderapi.PlaceholderAPI;
import org.bukkit.*;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.world.ChunkUnloadEvent;
import org.bukkit.plugin.Plugin;

import java.util.*;
import java.util.logging.Logger;

/**
 * @BelongsProject: SrWildEntity
 * @BelongsPackage: com.yuyu.srwildentity.listener
 * @FileName: EntityRefreshListener
 * @Author: 峰。
 * @Date: 2024/4/3-18:12
 * @Version: 1.0
 * @Description:监听类，控制怪物的刷新,同时注册指令，操控刷新
 */
public class EntityRefreshListener implements Listener, CommandExecutor {

    private ConfigManager configManager;//配置相关
    public static Logger log;
    public static boolean logBool;
    public static boolean flag; //用于验证entity是否刷新
    private Random random;//生成随机数,随机实体的定位
    public static HashMap<UUID,String> entityUUIDToPlayer = new HashMap<>();//uuid定位到玩家刷新对象
    private List<String> noRefreshPlayer;//记录不需要刷新的玩家
    private HashMap<String,PlayerRefreshLintener> refreshPlayer;//用来注册事件
    private Plugin plugin;
    private MythicMobs mythicMobs;




    public EntityRefreshListener(Logger logger, ConfigManager configManager, Plugin plugin){

        this.refreshPlayer = new HashMap<>();
        this.configManager = configManager;
        this.random = new Random();
        EntityRefreshListener.log = logger;
        this.flag = true;
        this.noRefreshPlayer = new ArrayList<>();
        this.plugin = plugin;
        logBool = false;
        //用于获取MM插件和萌芽的实例对象


    }

    /**
     * 注册监听事件
     * @param name
     */
    public void regRefreshEvent(String name){
        if (!refreshPlayer.containsKey(name)){
            if (logBool){
                log.info(ChatColor.RED+name+"玩家不在刷新列表!");
            }
            PlayerRefreshLintener playerRefreshLintener = new PlayerRefreshLintener(name,configManager);
            refreshPlayer.put(name, playerRefreshLintener);
        }
        if (!refreshPlayer.get(name).isFlag()) {
            int workId = plugin.getServer().getScheduler().scheduleSyncRepeatingTask(plugin, refreshPlayer.get(name)::timedRdfreshEneity, 0,
                    configManager.getRefreshTime() * 20);
            //把线程id记录到类中
            refreshPlayer.get(name).setWorkId(workId);
            refreshPlayer.get(name).setFlag(true);
            if (refreshPlayer.get(name).isFlag() && logBool) {
                log.info(ChatColor.GOLD+name+"被加入刷新集合");
            }
        }
    }

    /**
     * 取消注册的监听事件
     * @param name
     */
    public void cancleRefreshEvent(String name){
        if (!refreshPlayer.containsKey(name)){
            if (logBool){
                log.info(ChatColor.RED+name+"玩家不在刷新列表!");
            }
            return;
        }
        if (refreshPlayer.get(name).isFlag()) {
            plugin.getServer().getScheduler().cancelTask(refreshPlayer.get(name).getWorkId());
            refreshPlayer.get(name).setFlag(false);
        }
    }

    /**
     * 此类用于获取玩家的危险度
     * @param player
     */
    public static int prRisk(Player player){
        if (Bukkit.getPluginManager().isPluginEnabled("PlaceholderAPI")) {
            String placeholder = PlaceholderAPI.setPlaceholders(player, "%prisk_level%");
            int level = Integer.parseInt(placeholder);
            return level;
        }else {
            return 0;
        }
    }

    /**
     *注册的指令，可以通过指令去调解flag
     */
    @Override
    public boolean onCommand(CommandSender commandSender, Command command, String s, String[] strings) {

        if (!s.equalsIgnoreCase("despawn") && !s.equalsIgnoreCase("dsp")){
            return false;
        }

        if (strings.length == 1 && strings[0].equalsIgnoreCase("log")){
            logBool = !logBool;
            if (logBool){
                commandSender.sendMessage(ChatColor.GREEN+"实体刷新开启日志");
            }else {
                commandSender.sendMessage(ChatColor.GREEN+"实体刷新关闭日志");
            }
            return true;
        }

        if (commandSender.isOp()){
            if (strings.length == 0){
                //只输入despawn,直接停止刷新
                flag = !flag;
                if (flag){
                    //flag为true，开始重新刷新实体，此时遍历所有玩家，获取此时在野外的玩家
                    Collection<? extends Player> onlinePlayers = plugin.getServer().getOnlinePlayers();
                    for (Player player : onlinePlayers){
                        String name = player.getName();
                        if (!this.playerStayTown(player.getLocation())){
                            PlayerRefreshLintener playerRefreshLintener = new PlayerRefreshLintener(name,configManager);
                            refreshPlayer.put(name, playerRefreshLintener);
                            //注册监听事件
                            this.regRefreshEvent(name);
                        }
                        if (flag) {
                            log.info(ChatColor.GREEN + "所有在野外的玩家开始刷新实体");
                        }else {
                            log.info(ChatColor.GREEN+"实体刷新停止");
                            entityUUIDToPlayer.clear();
                            refreshPlayer.clear();
                        }
                        commandSender.sendMessage(ChatColor.GREEN+"所有在野外的玩家开始刷新实体");
                        return true;
                    }
                }else {
                    //flag=false，清空所有集合，停止刷新实体
                    entityUUIDToPlayer.clear();
                    refreshPlayer.clear();
                    if (logBool) {
                        log.info(ChatColor.AQUA + "所有玩家停止刷新实体");
                    }
                    commandSender.sendMessage(ChatColor.AQUA+"所有玩家停止刷新实体");
                    return true;
                }
            }else {
                String choice = strings[0];//只能是on，off或者clear
                if (choice.equalsIgnoreCase("on") || choice.equalsIgnoreCase("off")
                        || choice.equalsIgnoreCase("clear") || choice.equalsIgnoreCase("location")){
                    if (choice.equalsIgnoreCase("on")){
                        Player player = plugin.getServer().getPlayer(strings[1]);
                        if (player == null){
                            commandSender.sendMessage("请输入正确的玩家姓名!");
                            return true;
                        }else {
                            noRefreshPlayer.remove(strings[1]);
                            PlayerRefreshLintener playerRefreshinfo = new PlayerRefreshLintener(strings[1],configManager);
                            refreshPlayer.put(strings[1], playerRefreshinfo);
                            this.regRefreshEvent(strings[1]);
                            commandSender.sendMessage(ChatColor.YELLOW+strings[1]+"开始刷怪");
                            return true;
                        }
                    }else if (choice.equalsIgnoreCase("off")){
                        Player player = plugin.getServer().getPlayer(strings[1]);
                        if (player == null){
                            commandSender.sendMessage("请输入正确的玩家姓名!");
                            return true;
                        }else {
                            //玩家不为空
                            refreshPlayer.remove(strings[1]);
                            noRefreshPlayer.add(strings[1]);
                            this.cancleRefreshEvent(strings[1]);
                            commandSender.sendMessage(ChatColor.YELLOW+strings[1]+"停止刷怪");
                            return true;
                        }
                    }else if (choice.equalsIgnoreCase("clear")){
                        //清空刷新的怪物
                       this.clearRefreshEntity();
                       if (logBool) {
                           log.info(ChatColor.GOLD + "SrWildEntity刷新的所有实体被清除!");
                       }
                        commandSender.sendMessage(ChatColor.GOLD+"SrWildEntity刷新的所有实体被清除!");
                        return true;
                    }else if (choice.equalsIgnoreCase("location")){
                        if (commandSender instanceof Player){
                            Player player = (Player) commandSender;
                            Location location = player.getLocation();
                            String blockname = location.getBlock().getType().name();
                            player.sendMessage(ChatColor.GREEN+"x:"+location.getBlockX()+"\ty:"
                                    +location.getBlockY()+"\tz:"+location.getBlockZ()+"\tworld:"+location.getWorld().getName()+"\t"+blockname);
                            if (logBool) {
                                log.info(ChatColor.GREEN + "x:" + location.getBlockX() + "\ty:"
                                        + location.getBlockY() + "\tz:" + location.getBlockZ() + "\tworld:" + location.getWorld().getName() + "\t" + blockname);
                            }
                            return true;
                        }else {
                            return false;
                        }
                    }
                }
            }
        }else {
            commandSender.sendMessage(ChatColor.RED+"只有op能执行！");
            return false;
        }
        return false;
    }


    public void reloadSearch(){
        Collection<? extends Player> onlinePlayers = plugin.getServer().getOnlinePlayers();
        for (Player player : onlinePlayers){
            String name = player.getName();
            Town town = TownyAPI.getInstance().getTown(player.getLocation());
            if (town == null){
                PlayerRefreshLintener playerRefreshinfo = new PlayerRefreshLintener(name, configManager);
                refreshPlayer.put(name, playerRefreshinfo);
            }
            if (logBool) {
                log.info(ChatColor.GREEN + "所有在野外的玩家开始刷新实体");
            }
        }
    }

    /**
     * 玩家进入城镇,取消玩家的监听事件
     * @param event
     */
    @EventHandler
    public void onPlayerInTown(PlayerEnterTownEvent event) {

            String name = event.getPlayer().getName();
            this.cancleRefreshEvent(name);
            if (logBool) {
                log.info(name + "开始停止怪物");
            }

    }

    /**
     * 玩家复活
     * @param event
     */
    @EventHandler
    public void playerRevive(PlayerRespawnEvent event){
        Location respawnLocation = event.getRespawnLocation();
        if (!this.playerStayTown(respawnLocation)){
            // 返回true则表示在城镇，不用管
            //反之增加
            String name = event.getPlayer().getName();
            this.regRefreshEvent(name);
        }else {
            this.cancleRefreshEvent(event.getPlayer().getName());
        }
    }

    /**
     * 玩家离开城镇
     * @param event
     */
    @EventHandler
    public void onPlayerLeaveTown(PlayerLeaveTownEvent event) {
            String name = event.getPlayer().getName();
            this.regRefreshEvent(name);
    }

    /**
     * 玩家进入游戏后，要判断玩家登录的位置是否需要刷新怪物
     * @param event
     */
    @EventHandler
    public void onPlayerJoinGame(PlayerJoinEvent event) {
            Player player = event.getPlayer();
            String name = player.getName();
            if (!this.playerStayTown(player.getLocation()) && !noRefreshPlayer.contains(name)) {

                this.regRefreshEvent(name);
            }
    }

    /**
     * 用于玩家下线后停止刷新移出list集合
     * @param event
     */
    @EventHandler
    public void onPlayerOffOnline(PlayerQuitEvent event) {

            Player player = event.getPlayer();
            String name = player.getName();
            this.cancleRefreshEvent(name);
        if (!refreshPlayer.containsKey(name)){
            if (logBool){
                log.info(ChatColor.RED+name+"玩家不在刷新列表!");
            }
            return;
        }
        if (refreshPlayer.get(name).isFlag()) {
            plugin.getServer().getScheduler().cancelTask(refreshPlayer.get(name).getWorkId());
            refreshPlayer.get(name).setFlag(false);
        }
            if (logBool) {
                log.info(ChatColor.GOLD + "玩家被移出刷新集合");
            }

    }

    /**
     * 相关怪物死亡后，验证是否本插件刷新，再考虑需不需要操作
     * @param event
     */
    @EventHandler
    public void onEntityDeath(EntityDeathEvent event) {
       if (flag){
            LivingEntity entity = event.getEntity();
            UUID uniqueId = entity.getUniqueId();
            if (entityUUIDToPlayer.containsKey(uniqueId) && refreshPlayer.containsKey(entityUUIDToPlayer.get(uniqueId))) {
                //通过死亡实体的uuid获取玩家姓名然后删除uuid
                String playerName = entityUUIDToPlayer.get(uniqueId);
                refreshPlayer.get(playerName).getPlayerRefreshinfo().delEntityList(uniqueId);
                entityUUIDToPlayer.remove(uniqueId);
            }
        }
    }

    /**
     * 区块被卸载时，删除区块上的刷新的实体
     * @param event
     */
    @EventHandler
    public void despawnEntity(ChunkUnloadEvent event){
        Chunk chunk = event.getChunk();
        Entity[] entities = chunk.getEntities();
        for (Entity entity : entities){
            UUID uniqueId = entity.getUniqueId();
            if (entityUUIDToPlayer.containsKey(uniqueId)){
                //通过，则表示该实体记录在map集合中,需要删除
                entity.remove();

                //通过uuid获取对应的玩家姓名,然后通过玩家姓名获取对应的list集合
                String name = entityUUIDToPlayer.get(uniqueId);

                if (refreshPlayer.containsKey(name)) {
                    refreshPlayer.get(name).getPlayerRefreshinfo().delEntityList(uniqueId);
                }
            }
        }
    }




    /**
     * 清空所有记录在的实体
     */
    public void clearRefreshEntity(){
        Server server = plugin.getServer();
//        Collection<? extends Player> onlinePlayers = server.getOnlinePlayers();

        for (PlayerRefreshLintener player : refreshPlayer.values()){

            List<UUID> entityList = player.getPlayerRefreshinfo().getEntityList();
            for (UUID uuid : entityList){
                Entity entity = server.getEntity(uuid);
                if (entity != null){
                    entity.remove();
                    if (entityUUIDToPlayer.containsKey(uuid)){
                        entityUUIDToPlayer.remove(uuid);
                    }
                }else {
                    if (entityUUIDToPlayer.containsKey(uuid)){
                        entityUUIDToPlayer.remove(uuid);
                    }
                }
            }
            //entity清除完后
            player.getPlayerRefreshinfo().setEntityList(new ArrayList<>());
        }

        if(!entityUUIDToPlayer.isEmpty()) {
            for (UUID uuid : entityUUIDToPlayer.keySet()) {
                Entity entity = plugin.getServer().getEntity(uuid);
                if (entity != null) {
                    entity.remove();
                    entityUUIDToPlayer.remove(uuid);
                } else {
                    entityUUIDToPlayer.remove(uuid);
                }
            }
        }
    }

    public void playerRefreshEntiyt(String name){
        if (!noRefreshPlayer.contains(name) && !entityUUIDToPlayer.containsValue(name)) {

            PlayerRefreshLintener playerRefreshinfo = new PlayerRefreshLintener(name, configManager);
            refreshPlayer.put(name, playerRefreshinfo);
            if (logBool) {
                log.info(name + "开始刷新实体");
            }
        }else {
            List<UUID> uuidList = new ArrayList<>();
            for (UUID uuid : entityUUIDToPlayer.keySet()){
                String s = entityUUIDToPlayer.get(uuid);
                if (s.equals(name)){
                    uuidList.add(uuid);
                }
            }
            PlayerRefreshLintener playerRefreshinfo = new PlayerRefreshLintener(name, configManager);
            refreshPlayer.put(name, playerRefreshinfo);
            if (logBool) {
                log.info(name + "开始刷新实体");
            }
        }
    }

    /**
     * 用于判断玩家是否在城镇
     * @param location
     * @return
     */
    public boolean playerStayTown(Location location) {
        Town town = TownyAPI.getInstance().getTown(location);
        if (town == null){
            //为空则不再城镇
            return false;
        }else {
            return true;
        }
    }


    public ConfigManager getConfigManager() {
        return configManager;
    }


    public List<String> getNoRefreshPlayer() {
        return noRefreshPlayer;
    }

    public void setConfigManager(ConfigManager configManager) {
        this.configManager = configManager;
        for (String name : refreshPlayer.keySet()){
            refreshPlayer.get(name).setConfigManager(configManager);
        }
    }
}
